Supporting BIER in IPv6 Networks (BIERin6)
Zheng(Sandy) Zhang
ZTE Corporation
zhang.zheng@zte.com.cn
Zhaohui Zhang, Ed.
Juniper Networks
zzhang@juniper.net
IJsbrand Wijnands
Individual
ice@braindump.be
Mankamana Mishra
Cisco Systems
mankamis@cisco.com
Hooman Bidgoli
Nokia
hooman.bidgoli@nokia.com
Gyan Mishra
Verizon
gyan.s.mishra@verizon.com
BIER
BIER is a multicast forwarding architecture that does not require per-flow state inside the network yet still provides optimal replication. This document describes how the existing BIER encapsulation specified in RFC 8296 works in a non-MPLS IPv6 network, which is referred to as BIERin6. Specifically, like in an IPv4 network, BIER can work over L2 links directly or over tunnels. In case of IPv6 tunneling, a new IP "Next Header" type is to be assigned for BIER.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
BIER [RFC8279] is a multicast forwarding architecture that does not require per-flow state inside the network yet still provides optimal replication.
BIER forwarding with MPLS is IPv4/IPv6 agnostic. This document describes how BIER works in a non-MPLS IPv6 [RFC8200] environment using non-MPLS BIER encapsulation [RFC8296], with optional procedures specified for IPv6 specific features.
This document uses terminology defined in [RFC8279] and [RFC8296].

BIER over L2/Tunnels
[RFC8296] defines the BIER encapsulation format for MPLS and non-MPLS data planes. With a non-MPLS data plane, a BIER packet is the payload of an "outer" encapsulation, which could be a L2 link or a tunnel. The outer encapsulation has a "next header" field that is set to a value for "non-MPLS BIER". This "BIER over L2/Tunnel" model can be used as is in an IPv6 non-mpls environment, and is referred to as BIERin6.
If a BFR needs to tunnel BIER packets to another BFR, e.g. per [RFC8279] Section 6.9, while any type of tunnel will work, for best efficiency native IPv6 encapsulation can be used with the destination address being the downstream BFR and the Next Header field set to a to-be-assigned value for BIER.

                   +---------------+------------------------
                   |  IPv6 header  | BIER header + data
                   |               |
                   | Next Header = |
                   |    BIER       |
                   +---------------+------------------------

Between two directly connected BFRs, a BIER header can directly follow link layer header, e.g., an Ethernet header (with the Ethertype set to 0xAB37). Optionally, IPv6 encapsulation can be used even between directly connected BFRs (i.e. one-hop IPv6 tunneling) in the following two cases:
- An operator mandates all traffic to be carried in IPv6.
- A BFR does not have BIER support in its "fast forwarding path" and relies on "slow/software forwarding path", e.g. in IPv6 Home Networking [RFC7368] where high throughput multicast forwarding performance is not critical.

Considerations of Requirements for BIER in IPv6 Networks
[I-D.ietf-bier-ipv6-requirements] lists mandatory and optional requirements for BIER in IPv6 Networks. As a solution based on the BIER over L2/tunnel model [RFC8296], BIERin6 satisfies all the mandatory requirements.
For the two optional requirements for fragmentation and Encapsulating Security Payload (ESP), they can be satisfied by one of two ways:
- IPv6 based fragmentation/ESP: a BFIR encapsulates the payload in IPv6 with fragmentation and/or ESP header, and then the IPv6 packets are treated as BIER payload.
- Generic Fragmentation/ESP [I-D.zzhang-intarea-generic-delivery-functions]: a BFIR does generic fragmentation and/or ESP (without using IPv6 encapsulation) and the resulting packets are treated as BIER payload.
BIERin6 can support SRv6 based overlay services (e.g. MVPN/EVPN) with one of the following methods:
- An ingress PE (which is a BFIR) can encapsulate customer packets with an IPv6 header (with optional fragmentation and ESP extension headers). Any SRv6-based scheme can by used for service delimiting.
- Alternatively, since only the IPv6 address in the above-mentioned outer IPv6 header is used for service delimiting purpose, a new value can be assigned for the Proto field in the BIER header to indicate that an SRv6 Service SID [RFC9252] (instead of an entire IPv6 header) is added between the BIER header and original payload. For example, an End.DT2/4/6 service SID could be used to route the original payload in a corresponding VRF.
The details of fagmentation/ESP support and service delimitation are all outside the scope of this document.
BIERin6 being a solution based on [RFC8279] and [RFC8296], ECMP is inherently supported by BFRs using the the 20-bit entropy field in the BIER header for the load balancing hash. When a BIER packet is transported over an IPv6 tunnel, the entropy value is copied into the 20-bit IPv6 Flow Label [RFC6437], so that routers along the tunnel can do ECMP based on Flow Labels (instead of hashing based on 5-tuple of an IP packet). For a router along the tunnel doing deep packet inspection for ECMP purpose, if it understands BIER header it can go past the BIER header to look for the 5-tuple input key to a hash function. Otherwise, it stops at the BIER header. In either case the router will not mistake the BIER header as an IP header so no misordering should happen.
BIER has its own OAM functions independent of those related to the underlying links or tunnels. With BIERin6 following the "BIER over L2/tunnel" model, IPv6 OAM function and BIER OAM functions are used independently for their own purposes.
Specifically, BIERin6 works with all of the following OAM methods, or any future methods that are based on the "BIER over L2/tunnel" model:
- BIER OAM specified in [I-D.ietf-bier-ping]
- BIER BFD specified in [I-D.ietf-bier-bfd]
- BIER Performance Measurement specified in [I-D.ietf-bier-pmmm-oam]
- BIER Path Maximum Transmission Unit Discovery specified in [I-D.ietf-bier-path-mtu-discovery]
- BIER IOAM specified in [I-D.xzlnp-bier-ioam]

IPv6 Header
If IPv6 encapsulation is used to tunnel BIER packets (whether to a direct or indirect BIER neighbor), the Next Header field in the IPv6 Header (if there are no extension headers), or the Next Header field in the last extension header is set to TBD, indicating that the payload is a BIER packet.
If the neighbor is directly connected, The destination address in IPv6 header SHOULD be the neighbor's link-local address on this router's outgoing interface. The source destination address SHOULD be this router's link-local address on the outgoing interface, and the TTL MUST be set to 1.
If the neighbor is not directly connected, the destination address SHOULD be the BIER prefix of the BFR neighbor. The source address SHOULD be this router's BIER prefix, and the TTL MUST be large enough to get the packet to the BFR neighbor.
The "Flow label" field in the IPv6 packet SHOULD be copied from the entropy field in the BIER encapsulation.

BIER Header
The BIER header MUST be encoded per Section 2.2 of [RFC8296].
The BIFT-id is either encoded per [I-D.ietf-bier-non-mpls-bift-encoding] or per advertised by BFRs, as specified in [I-D.ietf-bier-lsr-non-mpls-extensions].

IPv6 Encapsulation Advertisement
When IPv6 encapsulation is not required between directly connected BFRs, no signaling in addition to that specified in [I-D.ietf-bier-lsr-non-mpls-extensions] is needed.
Otherwise, a node that requires IPv6 encapsulation MUST advertise the BIER IPv6 encapsulation sub-sub-sub-TLV/sub-sub-TLV according to local configuration or policy in the BIER domain to request other BFRs to always use IPv6 encapsulation.

Format
The BIER IPv6 Encapsulation is a new sub-sub-TLV of OSPFv3 BIER non-MPLS Encapsulation sub-TLV, and a new sub-sub-sub-TLV of ISIS BIER non-MPLS Encapsulation sub-sub-TLV as per [I-D.ietf-bier-lsr-non-mpls-extensions].

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    Type       |   Length      |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

- Type: For OSPF, value TBD1 indicates it is the IPv6 Encapsulation sub-TLV. For ISIS, value TBD2 indicates it is the IPv6 encapsulation sub-sub-TLV.
- Length: 0.

Inter-area prefix redistribution
When BFR-prefixes are advertised across IGP areas per [I-D.ietf-bier-lsr-non-mpls-extensions] or redistributed across protocol boundaries per [I-D.ietf-bier-prefix-redistribute], the BIER IPv6 encapsulation sub-sub-TLV or sub-sub-sub-TLV MAY be re-advertised/re-distributed as well.

IANA Considerations
IANA is requested to assign a "BIER" type for "Next Header" in the "Assigned Internet Protocol Numbers" registry.
IANA is requested to assign a "BIER IPv6 encapsulation Sub-sub-TLV" type in the "OSPFv3 BIER non-MPLS Encapsulation sub-TLV" Registry.
IANA is requested to assign a "BIER IPv6 encapsulation Sub-sub-sub-TLV" type in the "IS-IS BIER non-MPLS Encapsulation sub-sub-TLV" Registry.
IANA is requested to allocate a value "SRv6 Service" from "BIER Next Protocol Identifiers" registry to indicate that BIER payload starts with an SRv6 Service SID.

Security Considerations
General IPv6 and BIER security considerations apply.

Acknowledgement
The authors would like to thank Tony Przygienda, Nagendra Kumar for their review and valuable comments.

Normative References

Informative References
[RFC2119]
[RFC8174]
[RFC8279]
[RFC8200]
[RFC8296]
[RFC7368]
[I-D.ietf-bier-ipv6-requirements]
[I-D.zzhang-intarea-generic-delivery-functions]
[RFC9252]
[RFC6437]
[I-D.ietf-bier-ping]
[I-D.ietf-bier-bfd]
[I-D.ietf-bier-pmmm-oam]
[I-D.ietf-bier-path-mtu-discovery]
[I-D.xzlnp-bier-ioam]
[I-D.ietf-bier-non-mpls-bift-encoding]
[I-D.ietf-bier-lsr-non-mpls-extensions]
[I-D.ietf-bier-prefix-redistribute]